static const int buttonPin = 4;                  // switch pin
static const int Feedback_Pin = 18;                  // Feedback pin from ISD1820
int buttonStatePrevious = 1;                    // previousstate of the switch
unsigned long minButtonLongPressDuration = 600;  // Time we wait before we see the press as a long press
unsigned long buttonLongPressMillis;              // Time in ms when we the button was pressed
bool buttonStateLongPress = false;                // True if it is a long press
const int intervalButton = 50;                    // Time between two readings of the button state
unsigned long previousButtonMillis;               // Timestamp of the latest reading
unsigned long buttonPressDuration;                // Time the button is pressed in ms
unsigned long currentMillis;                      // Variabele to store the number of milleseconds since the Arduino has started
unsigned long startRectime;
unsigned long EndRectime;
bool playE = false;
bool reco = false;
const int rec = 16;
const int play = 17;
int timer_del = 0;
int timerDel2 = 0;
int recState = 0;
int playState = 0;

int LED_INDICATOR = 5;
void setup() {
  Serial.begin(115200);                 
  pinMode(buttonPin, INPUT_PULLUP);  
  pinMode(rec, OUTPUT);
  pinMode(play, OUTPUT);
  pinMode(LED_INDICATOR,OUTPUT);
  pinMode(Feedback_Pin, INPUT);
  digitalWrite(rec, 0);
  digitalWrite(play, playState);
    
   }

// Function for reading the button state
void readButtonState() {
  if (currentMillis - previousButtonMillis > intervalButton) {
    int buttonState = digitalRead(buttonPin);
    if (buttonState == 0 && buttonStatePrevious == 1 && !buttonStateLongPress) {
      buttonLongPressMillis = currentMillis;
      buttonStatePrevious = 0;
      Serial.println("Button pressed");
    }
    buttonPressDuration = currentMillis - buttonLongPressMillis;

    if (buttonState == 0 && !buttonStateLongPress && buttonPressDuration >= minButtonLongPressDuration) {
      buttonStateLongPress = true;
      buttonStatePrevious = 0;
      Serial.println("Button long pressed");
      getting_ready_for_record();
      
      reco = true;
    }
    if (buttonState == 1 && buttonStatePrevious == 0) {
      buttonStatePrevious = 1;
      buttonStateLongPress = false;
      digitalWrite(LED_INDICATOR, HIGH);
    delay(500);
    digitalWrite(LED_INDICATOR, LOW);
    delay(500);
      Serial.println("Button released");

      if (buttonPressDuration < minButtonLongPressDuration) {
        Serial.println("Button pressed shortly");
        playE = true;
      }
    }
    previousButtonMillis = currentMillis;
  }
}

void loop() {
  currentMillis = millis();  // store the current time
  readButtonState();         // read the button state
   digitalWrite(play, playState);

//if a single press occurs, playback starts looping
  if (playE) {
    playBack();
      }

//if long pressed the button, record will start
  if (reco) { 
    digitalWrite(LED_INDICATOR, HIGH); 
    record();
    reco = false;
  }
}

//recording function ---recording time may vary from 1 upto 20 seconds
void record() {
  Serial.println("Recording");

  long startTime = millis()/1000;
  long duration = 20; //up to 20sec

  while (millis()/1000 < startTime + duration) {
    digitalWrite(rec, 1);
  }
  digitalWrite(rec, 0);

}

//playback function 
void playBack() {
  playState=1;
  digitalWrite(play, playState);
  int timer_delay=timer_del;
  while(timer_delay>0){
    playState = 0;
    timer_delay=timer_delay-1;
    digitalWrite(play, playState);
    }
}  
//  
//  if (playState == 1) {
//    Serial.println("Playing");
//    if (millis() / 1000 - timer_del >= 1) {
//      playState = 0;
//      timer_del = timer_del+(millis() / 1000);
//    }
//  } else {
//    if (millis() / 1000 - timer_del >= 0.1) {
//      playState = 1;
//      timer_del = timer_del+(millis() / 1000);
//    }
//  }
//}
void getting_ready_for_record(){
  int timer=1;
  while(timer<=5){
    digitalWrite(LED_INDICATOR, HIGH);
    delay(500);
    digitalWrite(LED_INDICATOR, LOW);
    delay(500);
    timer=timer+1;
    
  }
  startRectime=millis();
  attachInterrupt(digitalPinToInterrupt(Feedback_Pin),recordingstate,RISING);  //  function for creating external interrupts at pin2 on Rising (LOW to HIGH vice versa)
    
}
void recordingstate(){
  digitalWrite(LED_INDICATOR, LOW);
  detachInterrupt(Feedback_Pin);
  reco = false;
  EndRectime=millis();
  timer_del= (EndRectime-startRectime)/1000;
  Serial.println("Recording ended with period of "+String(timer_del)+"sec");
}
